# Treehouse Full Stack JS Techdegree
# Project 1 — Random Quote Generator
# Made by Claudio Vallejo (04/27/16)

# Import file "interaction"
sketch = Framer.Importer.load("imported/interaction@1x")

# Remove framer cursor
document.body.style.cursor = "auto"

# Shortcut Layer Names from sketch["myLayer"] -> sketch
for layerGroupName of sketch
	window[layerGroupName] = sketch[layerGroupName]
	# Store original position of all elements from PSD/Sketch file
	sketch[layerGroupName].originalFrame = window[layerGroupName].frame

# Quotes Array
quotes = [copy1, copy2, copy3, copy4, copy5, copy6, copy7, copy8, copy9, copy10]

# Image Array
images = [image1, image2, image3, image4, image5, image6, image7, image8, image9, image10]

# Add Visible and Hidden States to Quotes
for copy in quotes
	copy.states.add
		visible:
			x: copy.x
			opacity: 1
		hidden:
			x: copy.x + 5
			opacity: 0
	
	copy.states.animationOptions = 
		curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
		time: 0.75
	
	copy.states.switchInstant('hidden')

# Add Visible and Hidden States to Images
for image in images
	image.states.add
		visible:
			x: image.x
			opacity: 1
		hidden:
			x: image.x - 5
			opacity: 0
		
	image.states.animationOptions = 
		curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
		time: 0.75
	
	image.states.switchInstant('hidden')

# Button Hover States
hover.states.add
	visible:
		opacity: 1
	hidden:
		opacity: 0

hover.states.animationOptions =
	curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
	time: 0.75

hover.states.switchInstant('hidden')

# Button Default States
button.states.add
	visible:
		opacity: 1
	hidden:
		opacity: 0

button.states.animationOptions =
	curve: "ease-in-out"
	time: 1

button.states.switchInstant('hidden')

# Button Hover-out State (Regular Cursor)
hover.on Events.MouseOut, ->
	hover.states.switch('hidden')
	document.body.style.cursor = "auto"

# Button Hover-in State (Pointer Cursor)
hover.on Events.MouseOver, ->
	hover.states.switch('visible')
	document.body.style.cursor = "pointer"
	
# Initial Profile's Index
indexValue = 0

# Load Fade-in Animation
Utils.delay 0.75, ->
	copy1.states.switch('visible')
	image1.states.switch('visible')
	
	Utils.delay 0.5, ->
		button.states.switch('visible')

# Function that grabs a Profile from the Copies and Images arrays
fetchQuote = ->
	
	if indexValue < 9
		quotes[indexValue].states.switch('hidden')
		images[indexValue].states.switch('hidden')
	
		Utils.delay 0.8, ->
			indexValue++
			quotes[indexValue].states.switch('visible')
			images[indexValue].states.switch('visible')
	
	else 
		quotes[indexValue].states.switch('hidden')
		images[indexValue].states.switch('hidden')
		
		Utils.delay 0.8, ->
			indexValue = 0
			quotes[indexValue].states.switch('visible')
			images[indexValue].states.switch('visible')

# On Button Press, Cycle through Quotes
hover.on Events.Click, ->
	fetchQuote()

# Right Keypress to Cycle through Quotes
# Events.wrap(document).addEventListener "keydown", (event) ->
# 	
# 	if event.keyCode is 39
# 		fetchQuote()

# Cycles through Profiles every 3s
# Utils.interval 3, ->
# 	fetchQuote()