# Treehouse Full Stack JS Techdegree
# Project 1 — Random Quote Generator
# Made by Claudio Vallejo (04/27/16)

# Import file "interaction"
sketch = Framer.Importer.load("imported/interaction@1x")

# Remove framer cursor
document.body.style.cursor = "auto"

# Shortcut Layer Names from sketch["myLayer"] -> sketch
for layerGroupName of sketch
	window[layerGroupName] = sketch[layerGroupName]
	# Store original position of all elements from PSD/Sketch file
	sketch[layerGroupName].originalFrame = window[layerGroupName].frame

# Copy Array
copies = [copy10, copy9, copy5, copy8, copy3, copy6, copy7, copy4, copy2, copy1]
copyClone = []

# Image Array
images = [image10, image9, image5, image8, image3, image6, image7, image4, image2, image1]
imageClone = []

# Add Visible and Hidden States to Copy
for copy in copies
	copy.states.add
		visible:
			x: copy.x
			opacity: 1
		hidden:
			x: copy.x + 5
			opacity: 0
	
	copy.states.animationOptions = 
		curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
		time: 0.75
	
	copy.states.switchInstant('hidden')

# Add Visible and Hidden States to Images
for image in images
	image.states.add
		visible:
			x: image.x
			opacity: 1
		hidden:
			x: image.x - 5
			opacity: 0
		
	image.states.animationOptions = 
		curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
		time: 0.75
	
	image.states.switchInstant('hidden')

# Button Hover States
hover.states.add
	visible:
		opacity: 1
	hidden:
		opacity: 0

hover.states.animationOptions =
	curve: "bezier-curve(0.45, 0.25, 0.25, 1)"
	time: 0.75

hover.states.switchInstant('hidden')

# Button Default States
button.states.add
	visible:
		opacity: 1
	hidden:
		opacity: 0

button.states.animationOptions =
	curve: "ease-in-out"
	time: 1

button.states.switchInstant('hidden')

# Button Hover-out State
hover.on Events.MouseOut, ->
	hover.states.switch('hidden')
	document.body.style.cursor = "auto"

# Button Hover-in State
hover.on Events.MouseOver, ->
	hover.states.switch('visible')
	document.body.style.cursor = "pointer"
	
# Current Profile's Index
indexValue = -1

# Animation on Load
Utils.delay 0.75, ->
	copy10.states.switch('visible')
	image10.states.switch('visible')
	indexValue = 0
	
# 	Utils.delay 0.5, ->
# 		button.states.switch('visible')

# Function that grabs a Profile from the Copies and Images arrays
fetchQuote = ->
	
	if indexValue < 3
		copies[indexValue].states.switch('hidden')
		images[indexValue].states.switch('hidden')
	
		Utils.delay 0.8, ->
			indexValue++
			copies[indexValue].states.switch('visible')
			images[indexValue].states.switch('visible')
	
	else 
		copies[indexValue].states.switch('hidden')
		images[indexValue].states.switch('hidden')
		
		Utils.delay 0.8, ->
			indexValue = 0
			copies[indexValue].states.switch('visible')
			images[indexValue].states.switch('visible')

# Button Click Events
Events.wrap(document).addEventListener "keydown", (event) ->
	
	if event.keyCode is 39
		fetchQuote()